# JSON Schema form generator RenderJS gadget

## What inside

gadget consists of three parts:

**first part: Main gadget for form generation**

[jsonform.gadget.html](jsonform.gadget.html)

 * Expand schema - download reference, multiple anyOf andOf optimisation
 to one level anyOf which transformed in array of schemas. Resulting array
 of schemas (schema_arr) is used in [gadget_json_generated_form_child.html](jsonform/gadget_json_generated_form_child.html)
 to generate schema selector. Contains various schema optimisations
 which reduce user choice according to schema logic.

 * Using of parent_gadget.downloadJSON() to resolve "urn:jio:" url schema
 links - it allows to use gadget inside officejs application and work
 with schemas saved in jio storage. Relative links are correctly resolved too.

 * During expanding new json schema document (generated_schema) is created. It is based on
 original json schema and its references are substituted by downloaded/resolved
 schema parts. Gadget downloads and resolves references on demand, this
 allows to work with circular infinite schemas.

 * json_document validation by modified tv4 library using generated_schema.

 * control of two types of circular references:

    * Hard Circular Reference (HCR): when all fields in download stack are required and
    stack is circular. Creation of valid document based on schema which contains HCR
    is impossible. Gadget reports error and breaks infinite loop if HCR is
    detected.

    * Soft Circular Reference (SCR): when all property fields in circular stack
     have one schema selection. Property fields containing one variant
     schema rendered immediately. If SCR is found then gadget marks schema
     as circular and breaks infinite loop. Schema generation continues,
     next subform is rendered on user request.

**second part: Gadget for recursive form generation**

[jsonform/gadget_json_generated_form_child.html](jsonform/gadget_json_generated_form_child.html)

 * html5 form render on base of json schema definition.

 * recursive gadget declaration for rendering array items and optional properties.

 * gadget uses tv4 validator for guess: on base of which schema variant
 json document is valid. Chosen variant is used for form rendering.

 * calculate element by dataPath - field path inside json document.
 This is used to display validation errors in correct places.

**third part: tv4**

[jsonform/tv4.js](jsonform/tv4.js)

modified version of original tv4.js. Difference from original:

* support of draft7 except if-then-else

* code which is responsible for references resolving and downloading is removed
 because tv4 does not work with circular schema.

## known limitations

Render limitations described below are not critical because json document
is rendered and correctly validated. Errors are alerted in case of document not
valid.

**string field rendering**

* `minLength` limiting realized as html5 regexp pattern attribute so it
 cannot be rendered simultaneously with `pattern` limiting.

**number field rendering**

* `multipleOf` limiting realized as html5 step attribute so `minimum`
limiting must be divisible by `multipleOf` without reminder for being rendered
simultaneously with `multipleOf`.

* `exclusiveMaximum` `exclusiveMinimum` limitation does not rendered

**object field rendering**

* `dependencies`, `maxProperties`, `minProperties` rendering is not
embodied

* schema can contain patternProperties and regular properties. If regular
 properties match pattern from patternProperties then two schemas need merging
 which is not realized.

* if schema has variation (anyOf or type is not specified) then schema selector
is rendered. If json document already contains value in field which is related to
specific schema variation then to change field type the field should be deleted and
readded. In this case user has no hint that schema has more than one variation.

**array field rendering**

* change items order currently unavailable

* `additionalItems` partial support

* `maxItems`, `uniqueItems` rendering is not supported

**json schema limitation**

* modified tv4 validator support draft7 schema, except if-then-else.

**reference resolver**

* id/$id is not used for change base url
